// #autoload
// #name = DEDEN Vehicle Station HUD
// #version = 0.0.1
// #date = February 28, 2002
// #status = Release
// #description = Changes the vehicle station HUD
// #author = ]S[DEDEN
// #warrior = DEDEN
// #email = warpath@strategyplanet.com
// #category = DEDEN Script

// Update List:
// ! Removed console spam from re-positioning old cancel button
// ! Added update features for vehicle list (polls vehicle totals once per second)

package DEDVehicleStationHUD {
//------------------------------------------------------------------------------------------
// Base Tribes 2 Function Overrides
//------------------------------------------------------------------------------------------
	function VehicleHud::loadHud( %obj, %tag ) {
		$Hud[%tag] = vehicleHud;
		$Hud[%tag].childGui = vehicleHud;
		$Hud[%tag].parent = vehicleHud;
	}


	function DEDVehicleStationHUDUpdateStatus(%count) {
		%count++;
		cancel(DEDVehicleStationHUD.Schedule);
		
		commandToServer('ShowHud', 'vehicleHud');
		if (%count < 600)
			DEDVehicleStationHUD.Schedule = schedule(1000, 0, "DEDVehicleStationHUDUpdateStatus", %count);
	}


	function VehicleHud::onWake(%this) {
		if ( isObject( hudMap ) ) {
			hudMap.pop();
			hudMap.delete();
		}

		$Hud[%tag] = vehicleHud;
		$Hud[%tag].childGui = vehicleHud;
		$Hud[%tag].parent = vehicleHud;
		
		new ActionMap( hudMap );
		hudMap.blockBind( moveMap, toggleInventoryHud );
		hudMap.blockBind( moveMap, toggleScoreScreen );
		hudMap.blockBind( moveMap, toggleCommanderMap );
		hudMap.bindCmd( keyboard, escape, "", "VehicleHud.onCancel();" );
		hudMap.bindCmd( keyboard, "1", "", "VehicleHud.quickBuy(1);" );
		hudMap.bindCmd( keyboard, "2", "", "VehicleHud.quickBuy(2);" );
		hudMap.bindCmd( keyboard, "3", "", "VehicleHud.quickBuy(3);" );
		hudMap.bindCmd( keyboard, "4", "", "VehicleHud.quickBuy(4);" );
		hudMap.bindCmd( keyboard, "5", "", "VehicleHud.quickBuy(5);" );
		hudMap.bindCmd( keyboard, "6", "", "VehicleHud.quickBuy(6);" );
		hudMap.push();
		
		DEDVehicleStationHUD.scoutVehicle = 0;
		DEDVehicleStationHUD.assaultVehicle = 0;
		DEDVehicleStationHUD.mobileBaseVehicle = 0;
		DEDVehicleStationHUD.scoutFlyer = 0;
		DEDVehicleStationHUD.bomberFlyer = 0;
		DEDVehicleStationHUD.hapcFlyer = 0;
		DEDVehicleStationHUDUpdateStatus(0);
	}


	function VehicleHud::quickBuy( %this, %id ) {
		%buy = false;
		if (%id == 1 && DEDVehicleStationHUD.scoutVehicle > 0) {
			VehicleHud.Selected = "scoutVehicle";
			%buy = true;
		} else if (%id == 2 && DEDVehicleStationHUD.assaultVehicle > 0) {
			VehicleHud.Selected = "assaultVehicle";
			%buy = true;
		} else if (%id == 3 && DEDVehicleStationHUD.mobileBaseVehicle > 0) {
			VehicleHud.Selected = "mobileBaseVehicle";
			%buy = true;
		} else if (%id == 4 && DEDVehicleStationHUD.scoutFlyer > 0) {
			VehicleHud.Selected = "scoutFlyer";
			%buy = true;
		} else if (%id == 5 && DEDVehicleStationHUD.bomberFlyer > 0) {
			VehicleHud.Selected = "bomberFlyer";
			%buy = true;
		} else if (%id == 6 && DEDVehicleStationHUD.hapcFlyer > 0) {
			VehicleHud.Selected = "hapcFlyer";
			%buy = true;
		}

		if (%buy)
			VehicleHud.onBuy();
	}

	function VehicleHud::onSleep( %this ) {
		%this.selected = "";
		for ( %line = 0; %line < $Hud['vehicleHud'].count; %line++ ) {
			if ( $Hud['vehicleHud'].data[%line, 0] !$= "" ) {
				$Hud['vehicleHud'].childGui.remove( $Hud['vehicleHud'].data[%line, 0] );
				$Hud['vehicleHud'].data[%line, 0] = "";
			}
		}

		$Hud['vehicleHud'].count = 0;
		
   		hudMap.pop();
   		hudMap.delete();
   		cancel(DEDVehicleStationHUD.Schedule);
	}


	function VehicleHud::onBuy(%this) {
		cancel(DEDVehicleStationHUD.Schedule);
		VIN_PicturescoutVehicle.opacity = "0.5";
		VIN_PictureassaultVehicle.opacity = "0.5";
		VIN_PicturemobileBaseVehicle.opacity = "0.5";
		VIN_PicturescoutFlyer.opacity = "0.5";
		VIN_PicturebomberFlyer.opacity = "0.5";
		VIN_PicturehapcFlyer.opacity = "0.5";
		toggleCursorHuds( 'vehicleHud' );
		commandToServer( 'buyVehicle', %this.selected );
	}



	function VehicleHud::addLine(%this, %tag, %lineNum, %name, %count) {
		%scale = getWord(getResolution(), 0) / 1024;

		%yOffset = mFloor(%scale * 260);
   		%yPos = (%lineNum * %yOffset) + mFloor(%scale * 50);

		if (%name $= "scoutVehicle") {
			%xPos = 10;
			%yPos = 50;
			DEDVehicleStationHUD.scoutVehicle = %count;
		} else if (%name $= "assaultVehicle") {
			%xPos = 10;
			%yPos = 310;
			DEDVehicleStationHUD.assaultVehicle = %count;
		} else if (%name $= "mobileBaseVehicle") {
			%xPos = 10;
			%yPos = 570;
			DEDVehicleStationHUD.mobileBaseVehicle = %count;
		} else if (%name $= "scoutFlyer") {
			%xPos = 758;
			%yPos = 50;
			DEDVehicleStationHUD.scoutFlyer = %count;
		} else if (%name $= "bomberFlyer") {
			%xPos = 758;
			%yPos = 310;
			DEDVehicleStationHUD.bomberFlyer = %count;
		} else if (%name $= "hapcFlyer") {
			%xPos = 758;
			%yPos = 570;
			DEDVehicleStationHUD.hapcFlyer = %count;
		}

		%pos = mFloor(%xPos * %scale) @ " " @ mFloor(%yPos * %scale);

   		%xSize = mFloor(%scale * 256);
   		%ySize = mFloor(%scale * 158);
   		%size = %xSize @ " " @ %ySize;
   		
		if (DEDVehicleStationHUD.LastSelected $= "") 
			DEDVehicleStationHUD.LastSelected = %name;


		$Hud[%tag].count++;

		%newbutton = "VIN_Picture" @ %name;
		if (isObject(%newbutton)) {
			%newbutton.delete();
		}

		$Hud[%tag].data[%lineNum, 0] = new HudBitmapCtrl(%newbutton) {
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = %pos;
			extent = %size;
			minExtent = "8 8";
			visible = "1";
			helpTag = "0";
			fillColor = "0.250000 0.250000 0.250000 1.000000";
			frameColor = "0.000000 1.000000 0.000000 1.000000";
			opacity = "0.5";
			autoCenter = "0";
			autoResize = "0";
			flipVertical = "0";
			flipHorizontal = "0";
			bitmap="gui/vin_" @ %name;

			new GuiTextCtrl(%newbutton @ "Text") {
				profile = "DEDVehicleStationHUDTextProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "5 0";
				extent = "117 22";
				minExtent = "8 8";
				visible = "1";
				helpTag = "0";
				text = %count @ " Remaining";
			};
			
			// Mouse event handler.
			new GuiMouseEventCtrl(%name @ "MouseEvent") {
				profile = "DefaultProfile";
				position = "0 0";
				extent = %size;
				vertSizing = "top";
				horizSizing = "left";
				visible = "true";
			};
		};

		return 1;
	}


	// Scout Vehicle (Grav Cycle) button
	function scoutVehicleMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PicturescoutVehicle.opacity = "1";
		VehicleHud.selected = "scoutVehicle";
	}

	function scoutVehicleMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PicturescoutVehicle.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "scoutVehicle";
	}
	
	function scoutVehicleMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}


	// Assault Vehicle (Tank) button
	function assaultVehicleMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PictureassaultVehicle.opacity = "1";
		VehicleHud.selected = "assaultVehicle";
	}

	function assaultVehicleMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PictureassaultVehicle.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "assaultVehicle";
	}
	
	function assaultVehicleMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}



	// Mobile Base Vehicle (MPB) button
	function mobileBaseVehicleMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PicturemobileBaseVehicle.opacity = "1";
		VehicleHud.selected = "mobileBaseVehicle";
	}

	function mobileBaseVehicleMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PicturemobileBaseVehicle.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "mobileBaseVehicle";
	}
	
	function mobileBaseVehicleMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}


	// Scout Flyer (Shrike) button
	function scoutFlyerMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PicturescoutFlyer.opacity = "1";
		VehicleHud.selected = "scoutFlyer";
	}

	function scoutFlyerMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PicturescoutFlyer.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "scoutFlyer";
	}
	
	function scoutFlyerMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}


	// Bomber Flyer (Bomber) button
	function bomberFlyerMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PicturebomberFlyer.opacity = "1";
		VehicleHud.selected = "bomberFlyer";
	}

	function bomberFlyerMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PicturebomberFlyer.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "bomberFlyer";
	}
	
	function bomberFlyerMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}


	// HAPC Flyer (HAVOC) button
	function hapcFlyerMouseEvent::onMouseEnter(%this, %mod, %pos, %count) {
		VIN_PicturehapcFlyer.opacity = "1";
		VehicleHud.selected = "hapcFlyer";
	}

	function hapcFlyerMouseEvent::onMouseLeave(%this, %mod, %pos, %count) {
		VIN_PicturehapcFlyer.opacity = "0.5";
		DEDVehicleStationHUD.LastButtonSelected = "hapcFlyer";
	}
	
	function hapcFlyerMouseEvent::onMouseDown(%this, %item, %pos) {
		VehicleHud.onBuy();
	}

	function DEDVehicleStationHUDResetDblClick() {
		DEDVehicleStationHUD.DblClicker = false;
	}

	function vehicleHudMouseEvent::onRightMouseDown(%this) {
		cancel(DEDVehicleStationHUD.DblSchedule);
		if (DEDVehicleStationHUD.DblClicker) {
			VehicleHud.onCancel();
			DEDVehicleStationHUD.DblClicker = false;
		} else {
			DEDVehicleStationHUD.DblClicker = true;
			DEDVehicleStationHUD.DblSchedule = schedule(200, 0, "DEDVehicleStationHUDResetDblClick");
		}
		
	}


	function setLineHud(%msgType, %msgString, %hudName, %lineNumber, %a0, %a1, %a2, %a3, %a4) {
		%tag = getWord(%hudName, 0);
		%lineNum = detag(%lineNumber);

		if (%tag !$= 'vehicleHud') {
			if(!isObject($Hud[%tag].data[%lineNum, 0])) {
				$Hud[%tag].numCol = addLine(%tag, %lineNum, %a0, %a1, %a2, %a3);
				for(%i = 0; %i < $Hud[%tag].numCol; %i++)
					$Hud[%tag].childGui.add($Hud[%tag].data[%lineNum, %i]);
			}
		
			for(%i = 0; %i < $Hud[%tag].numCol; %i++)
				$Hud[%tag].data[%lineNum, %i].hudSetValue(detag(%a[%i]),detag(%a4));
		} else {
			$Hud[%tag].numCol = addLine(%tag, %lineNum, %a0, %a1, %a2, %a3);
			for(%i = 0; %i < $Hud[%tag].numCol; %i++)
				$Hud[%tag].childGui.add($Hud[%tag].data[%lineNum, %i]);
		}

		//don't forget to adjust the size accordingly...
		if (%tag $= 'scoreScreen') {
			%height = 0;
			%guiCtrl = $Hud[%tag].childGui;

			//set the new extent to be the position + extent of the last element...
			%height = 0;
			if (%guiCtrl.getCount() > 0) {
				%lastCtrl = %guiCtrl.getObject(%guiCtrl.getCount() - 1);
				%height = getWord(%lastCtrl.position, 1) + getWord(%lastCtrl.extent, 1);
			}

			//now reset the extent
			%guiCtrl.resize(getWord(%guiCtrl.position, 0), getWord(%guiCtrl.position, 1), getWord(%guiCtrl.extent, 0), %height);
		}
	}


};


// Create the DEDVehicleStationHUD object if it does not already exist.
if(!isObject(DEDVehicleStationHUD)) {
	new ScriptObject(DEDVehicleStationHUD) {
		class = DEDVehicleStationHUD;
	};
}

// Activate the DEDVehicleStationHUD package.
activatePackage(DEDVehicleStationHUD);



new GuiControlProfile ("DEDVehicleStationHUDTextProfile") {
	fontType = "Verdana Bold";//$ShellLabelFont;
	fontSize = 14;
	fontColor = "255 255 255";
	autoSizeWidth = false;
	autoSizeHeight = false;
};


if (isObject(vehicleHud)) {
	vehicleHud.delete();
}


new GuiControl(vehicleHud) {
	profile = "GuiDefaultProfile";
	horizSizing = "right";
	vertSizing = "bottom";
	position = "0 0";
	extent = "640 480";
	minExtent = "8 8";
	visible = "1";
	helpTag = "0";

	new GuiMouseEventCtrl("vehicleHudMouseEvent") {
		profile = "DefaultProfile";
		vertSizing = "height";
		horizSizing = "width";
		position = "0 0";
		extent = getWord(getResolution(), 0) @ " " @ getWord(getResolution(), 1);
		visible = "true";
	};
};
